package do

import (
	"encoding/json"
	"strconv"
	"trasfer_middleware/cmd/rpc/internal/logic/vo"
	"trasfer_middleware/genModel"
)

type Res struct {
	Code    float64                `json:"code"`
	Data    map[string]interface{} `json:"data"`
	Message string                 `json:"message"`
}

func NewMarketKeyDataSet(order *genModel.ServerOrderNewMarket, resq string, resp string) (err error) {
	var (
		orderInfoReq map[string]interface{}
		orderInfoRes Res
	)
	err = json.Unmarshal([]byte(resp), &orderInfoRes)

	if orderInfoRes.Code != vo.NEW_MARKET_SUCCESS {
		return err
	}
	err = json.Unmarshal([]byte(resq), &orderInfoReq)
	if err != nil {
		return err
	}
	order.Number, err = strconv.ParseInt(orderInfoReq["number"].(string), 16, 64)
	if err != nil {
		return err
	}
	order.AppId = orderInfoReq["app_id"].(string)
	if err != nil {
		return err
	}
	order.ActivityNo = orderInfoReq["activity_no"].(string)

	order.OutBizNo = orderInfoRes.Data["out_biz_no"].(string)
	order.Key = orderInfoRes.Data["key"].(string)
	order.TradeNo = orderInfoRes.Data["trade_no"].(string)
	order.Url = orderInfoRes.Data["url"].(string)
	return nil
}
