package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalCusBalanceLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalCusBalanceLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalCusBalanceLogic {
	return &PhysicalCusBalanceLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalCusBalanceLogic) PhysicalCusBalance(in *transfer.EmptyReqs) (*transfer.PhysicalCusBalanceRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).CusBalance()

	return res, err
}
