package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalCusLogsLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalCusLogsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalCusLogsLogic {
	return &PhysicalCusLogsLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalCusLogsLogic) PhysicalCusLogs(in *transfer.PhysicalCusLogsReq) (*transfer.PhysicalCusLogsRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).CusBalanceHis()

	return res, err
}
