package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalExpressListLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalExpressListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalExpressListLogic {
	return &PhysicalExpressListLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalExpressListLogic) PhysicalExpressList(in *transfer.PhysicalExpressListReq) (*transfer.PhysicalExpressListRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).ExpressList()

	return res, err
}
