package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalFinanceBillLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalFinanceBillLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalFinanceBillLogic {
	return &PhysicalFinanceBillLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalFinanceBillLogic) PhysicalFinanceBill(in *transfer.PhysicalFinanceBillReq) (*transfer.PhysicalFinanceBillRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).FinanceBill()

	return res, err
}
