package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalGoodsListLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalGoodsListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalGoodsListLogic {
	return &PhysicalGoodsListLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalGoodsListLogic) PhysicalGoodsList(in *transfer.PhysicalGoodsListReq) (*transfer.PhysicalGoodsListRes, error) {

	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).GoodsList()

	return res, err
}
