package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalGoodsStockLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalGoodsStockLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalGoodsStockLogic {
	return &PhysicalGoodsStockLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalGoodsStockLogic) PhysicalGoodsStock(in *transfer.PhysicalGoodsStockReq) (*transfer.PhysicalGoodsStockRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).GoodsStock()

	return res, err
}
