package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalOrderAfterReturnLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalOrderAfterReturnLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalOrderAfterReturnLogic {
	return &PhysicalOrderAfterReturnLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalOrderAfterReturnLogic) PhysicalOrderAfterReturn(in *transfer.PhysicalOrderAfterReturnReq) (*transfer.PhysicalOrderAfterReturnRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).OrderAfterReturn()

	return res, err
}
