package logic

import (
	"context"
	"trasfer_middleware/until/common"

	"trasfer_middleware/cmd/rpc/internal/svc"
	"trasfer_middleware/cmd/rpc/pb/transfer"

	"github.com/zeromicro/go-zero/core/logx"
)

type PhysicalOrderCloseLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewPhysicalOrderCloseLogic(ctx context.Context, svcCtx *svc.ServiceContext) *PhysicalOrderCloseLogic {
	return &PhysicalOrderCloseLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *PhysicalOrderCloseLogic) PhysicalOrderClose(in *transfer.PhysicalOrderCloseReq) (*transfer.PhysicalOrderCloseRes, error) {
	res, err := l.svcCtx.Physical.SetData(l.ctx, in.AppId, common.StructToMap(in), &l.svcCtx.Config.Mq).OrderClose()

	return res, err
}
