package po

import (
	"encoding/json"
	"github.com/sleepinggodoflove/lansexiongdi-marketing-sdk/api/v1/key"
	"time"
	"trasfer_middleware/cmd/rpc/etc"
	"trasfer_middleware/genModel"
	"trasfer_middleware/until/common"
	"trasfer_middleware/until/request"
)

type RequestStruct struct {
	RequestBody map[string]string
	Config      etc.RockerMqConfig
}

type RequestStructWithJson struct {
	RequestBody map[string]interface{}
	Config      etc.RockerMqConfig
}

func SetMqSendDataMarket(reqInfo *RequestStruct, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(reqInfo, respInfo, url)
	logByte, _ := json.Marshal(log)
	return logByte
}

func SetMqSendDataZLTX(reqInfo *RequestStruct, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(reqInfo, respInfo, url)
	logByte, _ := json.Marshal(log)
	return logByte
}

func SetMqSendDataNewMarket(reqInfo *RequestStruct, respInfo *key.Response, url string) []byte {

	resp, _ := json.Marshal(respInfo)
	log := commonMqSendData(reqInfo, &request.Response{
		Text:       string(resp),
		StatusCode: int(respInfo.Code),
	}, url)
	logByte, _ := json.Marshal(log)
	return logByte
}
func SetMqSendDataPhysical(reqInfo *RequestStructWithJson, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(reqInfo, respInfo, url)
	logByte, _ := json.Marshal(log)
	return logByte
}

func SetMqSendDataRs(rsReq *RequestStruct, order *genModel.ServerOrderRs, respInfo *request.Response, url string) []byte {
	log := commonMqSendData(rsReq, respInfo, url)
	OrderMap := common.StructToMap(order)
	log = common.MergeMaps(OrderMap, log)
	logByte, _ := json.Marshal(log)
	return logByte
}

func commonMqSendData(reqData interface{}, respInfo *request.Response, url string) map[string]interface{} {
	log := make(map[string]interface{}, 5)
	reqStr, _ := json.Marshal(reqData)
	log["data"] = string(reqStr)
	log["url"] = url
	log["resp"] = respInfo.Text
	log["code"] = respInfo.StatusCode
	log["create_time"] = time.Now().Format("2006-01-02 15:04:05")

	return log
}
