package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerMiddleNewMarketLogsModel = (*customServerMiddleNewMarketLogsModel)(nil)

type (
	// ServerMiddleNewMarketLogsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerMiddleNewMarketLogsModel.
	ServerMiddleNewMarketLogsModel interface {
		serverMiddleNewMarketLogsModel
		withSession(session sqlx.Session) ServerMiddleNewMarketLogsModel
	}

	customServerMiddleNewMarketLogsModel struct {
		*defaultServerMiddleNewMarketLogsModel
	}
)

// NewServerMiddleNewMarketLogsModel returns a model for the database table.
func NewServerMiddleNewMarketLogsModel(conn sqlx.SqlConn) ServerMiddleNewMarketLogsModel {
	return &customServerMiddleNewMarketLogsModel{
		defaultServerMiddleNewMarketLogsModel: newServerMiddleNewMarketLogsModel(conn),
	}
}

func (m *customServerMiddleNewMarketLogsModel) withSession(session sqlx.Session) ServerMiddleNewMarketLogsModel {
	return NewServerMiddleNewMarketLogsModel(sqlx.NewSqlConnFromSession(session))
}
