// Code generated by goctl. DO NOT EDIT.

package genModel

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	serverMiddleNewMarketLogsFieldNames          = builder.RawFieldNames(&ServerMiddleNewMarketLogs{})
	serverMiddleNewMarketLogsRows                = strings.Join(serverMiddleNewMarketLogsFieldNames, ",")
	serverMiddleNewMarketLogsRowsExpectAutoSet   = strings.Join(stringx.Remove(serverMiddleNewMarketLogsFieldNames, "`log_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	serverMiddleNewMarketLogsRowsWithPlaceHolder = strings.Join(stringx.Remove(serverMiddleNewMarketLogsFieldNames, "`log_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	serverMiddleNewMarketLogsModel interface {
		Insert(ctx context.Context, data *ServerMiddleNewMarketLogs) (sql.Result, error)
		FindOne(ctx context.Context, logId uint64) (*ServerMiddleNewMarketLogs, error)
		Update(ctx context.Context, data *ServerMiddleNewMarketLogs) error
		Delete(ctx context.Context, logId uint64) error
	}

	defaultServerMiddleNewMarketLogsModel struct {
		conn  sqlx.SqlConn
		table string
	}

	ServerMiddleNewMarketLogs struct {
		LogId      uint64    `db:"log_id"`
		Url        string    `db:"url"`
		Type       string    `db:"type"`
		Code       int64     `db:"code"`
		Data       string    `db:"data"`
		Resp       string    `db:"resp"`
		CreateTime time.Time `db:"create_time"`
		UpdateTime time.Time `db:"update_time"`
		Status     int64     `db:"status"`
	}
)

func newServerMiddleNewMarketLogsModel(conn sqlx.SqlConn) *defaultServerMiddleNewMarketLogsModel {
	return &defaultServerMiddleNewMarketLogsModel{
		conn:  conn,
		table: "`server_middle_new_market_logs`",
	}
}

func (m *defaultServerMiddleNewMarketLogsModel) Delete(ctx context.Context, logId uint64) error {
	query := fmt.Sprintf("delete from %s where `log_id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, logId)
	return err
}

func (m *defaultServerMiddleNewMarketLogsModel) FindOne(ctx context.Context, logId uint64) (*ServerMiddleNewMarketLogs, error) {
	query := fmt.Sprintf("select %s from %s where `log_id` = ? limit 1", serverMiddleNewMarketLogsRows, m.table)
	var resp ServerMiddleNewMarketLogs
	err := m.conn.QueryRowCtx(ctx, &resp, query, logId)
	switch err {
	case nil:
		return &resp, nil
	case sqlx.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultServerMiddleNewMarketLogsModel) Insert(ctx context.Context, data *ServerMiddleNewMarketLogs) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?)", m.table, serverMiddleNewMarketLogsRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.Url, data.Type, data.Code, data.Data, data.Resp, data.Status)
	return ret, err
}

func (m *defaultServerMiddleNewMarketLogsModel) Update(ctx context.Context, data *ServerMiddleNewMarketLogs) error {
	query := fmt.Sprintf("update %s set %s where `log_id` = ?", m.table, serverMiddleNewMarketLogsRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.Url, data.Type, data.Code, data.Data, data.Resp, data.Status, data.LogId)
	return err
}

func (m *defaultServerMiddleNewMarketLogsModel) tableName() string {
	return m.table
}
