package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerMiddlePhysicalLogsModel = (*customServerMiddlePhysicalLogsModel)(nil)

type (
	// ServerMiddlePhysicalLogsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerMiddlePhysicalLogsModel.
	ServerMiddlePhysicalLogsModel interface {
		serverMiddlePhysicalLogsModel
		withSession(session sqlx.Session) ServerMiddlePhysicalLogsModel
	}

	customServerMiddlePhysicalLogsModel struct {
		*defaultServerMiddlePhysicalLogsModel
	}
)

// NewServerMiddlePhysicalLogsModel returns a model for the database table.
func NewServerMiddlePhysicalLogsModel(conn sqlx.SqlConn) ServerMiddlePhysicalLogsModel {
	return &customServerMiddlePhysicalLogsModel{
		defaultServerMiddlePhysicalLogsModel: newServerMiddlePhysicalLogsModel(conn),
	}
}

func (m *customServerMiddlePhysicalLogsModel) withSession(session sqlx.Session) ServerMiddlePhysicalLogsModel {
	return NewServerMiddlePhysicalLogsModel(sqlx.NewSqlConnFromSession(session))
}
