// Code generated by goctl. DO NOT EDIT.

package genModel

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	serverMiddlePhysicalLogsFieldNames          = builder.RawFieldNames(&ServerMiddlePhysicalLogs{})
	serverMiddlePhysicalLogsRows                = strings.Join(serverMiddlePhysicalLogsFieldNames, ",")
	serverMiddlePhysicalLogsRowsExpectAutoSet   = strings.Join(stringx.Remove(serverMiddlePhysicalLogsFieldNames, "`log_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	serverMiddlePhysicalLogsRowsWithPlaceHolder = strings.Join(stringx.Remove(serverMiddlePhysicalLogsFieldNames, "`log_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	serverMiddlePhysicalLogsModel interface {
		Insert(ctx context.Context, data *ServerMiddlePhysicalLogs) (sql.Result, error)
		FindOne(ctx context.Context, logId uint64) (*ServerMiddlePhysicalLogs, error)
		Update(ctx context.Context, data *ServerMiddlePhysicalLogs) error
		Delete(ctx context.Context, logId uint64) error
	}

	defaultServerMiddlePhysicalLogsModel struct {
		conn  sqlx.SqlConn
		table string
	}

	ServerMiddlePhysicalLogs struct {
		LogId      uint64    `db:"log_id"`
		Url        string    `db:"url"`
		Code       int64     `db:"code"`
		Data       string    `db:"data"`
		Resp       string    `db:"resp"`
		CreateTime time.Time `db:"create_time"`
		UpdateTime time.Time `db:"update_time"`
		Status     int64     `db:"status"`
	}
)

func newServerMiddlePhysicalLogsModel(conn sqlx.SqlConn) *defaultServerMiddlePhysicalLogsModel {
	return &defaultServerMiddlePhysicalLogsModel{
		conn:  conn,
		table: "`server_middle_physical_logs`",
	}
}

func (m *defaultServerMiddlePhysicalLogsModel) Delete(ctx context.Context, logId uint64) error {
	query := fmt.Sprintf("delete from %s where `log_id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, logId)
	return err
}

func (m *defaultServerMiddlePhysicalLogsModel) FindOne(ctx context.Context, logId uint64) (*ServerMiddlePhysicalLogs, error) {
	query := fmt.Sprintf("select %s from %s where `log_id` = ? limit 1", serverMiddlePhysicalLogsRows, m.table)
	var resp ServerMiddlePhysicalLogs
	err := m.conn.QueryRowCtx(ctx, &resp, query, logId)
	switch err {
	case nil:
		return &resp, nil
	case sqlx.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultServerMiddlePhysicalLogsModel) Insert(ctx context.Context, data *ServerMiddlePhysicalLogs) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, serverMiddlePhysicalLogsRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.Url, data.Code, data.Data, data.Resp, data.Status)
	return ret, err
}

func (m *defaultServerMiddlePhysicalLogsModel) Update(ctx context.Context, data *ServerMiddlePhysicalLogs) error {
	query := fmt.Sprintf("update %s set %s where `log_id` = ?", m.table, serverMiddlePhysicalLogsRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.Url, data.Code, data.Data, data.Resp, data.Status, data.LogId)
	return err
}

func (m *defaultServerMiddlePhysicalLogsModel) tableName() string {
	return m.table
}
