package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerOrderNewMarketModel = (*customServerOrderNewMarketModel)(nil)

type (
	// ServerOrderNewMarketModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerOrderNewMarketModel.
	ServerOrderNewMarketModel interface {
		serverOrderNewMarketModel
		withSession(session sqlx.Session) ServerOrderNewMarketModel
	}

	customServerOrderNewMarketModel struct {
		*defaultServerOrderNewMarketModel
	}
)

// NewServerOrderNewMarketModel returns a model for the database table.
func NewServerOrderNewMarketModel(conn sqlx.SqlConn) ServerOrderNewMarketModel {
	return &customServerOrderNewMarketModel{
		defaultServerOrderNewMarketModel: newServerOrderNewMarketModel(conn),
	}
}

func (m *customServerOrderNewMarketModel) withSession(session sqlx.Session) ServerOrderNewMarketModel {
	return NewServerOrderNewMarketModel(sqlx.NewSqlConnFromSession(session))
}
