// Code generated by goctl. DO NOT EDIT.

package genModel

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	serverOrderNewMarketFieldNames          = builder.RawFieldNames(&ServerOrderNewMarket{})
	serverOrderNewMarketRows                = strings.Join(serverOrderNewMarketFieldNames, ",")
	serverOrderNewMarketRowsExpectAutoSet   = strings.Join(stringx.Remove(serverOrderNewMarketFieldNames, "`order_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	serverOrderNewMarketRowsWithPlaceHolder = strings.Join(stringx.Remove(serverOrderNewMarketFieldNames, "`order_id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	serverOrderNewMarketModel interface {
		Insert(ctx context.Context, data *ServerOrderNewMarket) (sql.Result, error)
		FindOne(ctx context.Context, orderId uint64) (*ServerOrderNewMarket, error)
		Update(ctx context.Context, data *ServerOrderNewMarket) error
		Delete(ctx context.Context, orderId uint64) error
		FindByOutBizId(ctx context.Context, outBizId string) (*ServerOrderNewMarket, error)
	}

	defaultServerOrderNewMarketModel struct {
		conn  sqlx.SqlConn
		table string
	}

	ServerOrderNewMarket struct {
		OrderId    uint64    `db:"order_id"`
		OutBizNo   string    `db:"out_biz_no"`  // 用户侧流水号
		ActivityNo string    `db:"activity_no"` // 活动id
		Number     int64     `db:"number"`      // 数量
		AppId      string    `db:"app_id"`      // 平台提供商品id
		TradeNo    string    `db:"trade_no"`    // 平台订单号
		Key        string    `db:"key"`
		Url        string    `db:"url"`      // 地址
		ReqTime    time.Time `db:"req_time"` // 请求时间
		CreateTime time.Time `db:"create_time"`
		UpdateTime time.Time `db:"update_time"`
		Status     int64     `db:"status"` // 状态
		LogId      int64     `db:"log_id"` // 对应的日志id
	}
)

func newServerOrderNewMarketModel(conn sqlx.SqlConn) *defaultServerOrderNewMarketModel {
	return &defaultServerOrderNewMarketModel{
		conn:  conn,
		table: "`server_order_new_market`",
	}
}

func (m *defaultServerOrderNewMarketModel) Delete(ctx context.Context, orderId uint64) error {
	query := fmt.Sprintf("delete from %s where `order_id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, orderId)
	return err
}

func (m *defaultServerOrderNewMarketModel) FindOne(ctx context.Context, orderId uint64) (*ServerOrderNewMarket, error) {
	query := fmt.Sprintf("select %s from %s where `order_id` = ? limit 1", serverOrderNewMarketRows, m.table)
	var resp ServerOrderNewMarket
	err := m.conn.QueryRowCtx(ctx, &resp, query, orderId)
	switch err {
	case nil:
		return &resp, nil
	case sqlx.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultServerOrderNewMarketModel) Insert(ctx context.Context, data *ServerOrderNewMarket) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, serverOrderNewMarketRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.OutBizNo, data.ActivityNo, data.Number, data.AppId, data.TradeNo, data.Key, data.Url, data.ReqTime, data.Status, data.LogId)
	return ret, err
}

func (m *defaultServerOrderNewMarketModel) Update(ctx context.Context, data *ServerOrderNewMarket) error {
	query := fmt.Sprintf("update %s set %s where `order_id` = ?", m.table, serverOrderNewMarketRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.OutBizNo, data.ActivityNo, data.Number, data.AppId, data.TradeNo, data.Key, data.Url, data.ReqTime, data.Status, data.LogId, data.OrderId)
	return err
}

func (m *defaultServerOrderNewMarketModel) FindByOutBizId(ctx context.Context, outBizId string) (*ServerOrderNewMarket, error) {
	query := fmt.Sprintf("select %s from %s where `out_biz_no` = ? limit 1", serverOrderNewMarketRows, m.table)
	var resp ServerOrderNewMarket
	err := m.conn.QueryRowCtx(ctx, &resp, query, outBizId)
	switch err {
	case nil:
		return &resp, nil
	case sqlx.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultServerOrderNewMarketModel) tableName() string {
	return m.table
}
