package genModel

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ ServerOrderPhysicalModel = (*customServerOrderPhysicalModel)(nil)

type (
	// ServerOrderPhysicalModel is an interface to be customized, add more methods here,
	// and implement the added methods in customServerOrderPhysicalModel.
	ServerOrderPhysicalModel interface {
		serverOrderPhysicalModel
		withSession(session sqlx.Session) ServerOrderPhysicalModel
	}

	customServerOrderPhysicalModel struct {
		*defaultServerOrderPhysicalModel
	}
)

// NewServerOrderPhysicalModel returns a model for the database table.
func NewServerOrderPhysicalModel(conn sqlx.SqlConn) ServerOrderPhysicalModel {
	return &customServerOrderPhysicalModel{
		defaultServerOrderPhysicalModel: newServerOrderPhysicalModel(conn),
	}
}

func (m *customServerOrderPhysicalModel) withSession(session sqlx.Session) ServerOrderPhysicalModel {
	return NewServerOrderPhysicalModel(sqlx.NewSqlConnFromSession(session))
}
